#!/bin/sh

DM_SVN_URL=https://subversion.xray.aps.anl.gov/DataManagement

MY_DIR=`dirname $0` && cd $MY_DIR && MY_DIR=`pwd`
if [ -z "${DM_ROOT_DIR}" ]; then
    DM_ROOT_DIR=$MY_DIR/..
fi
DM_SUPPORT_DIR=$DM_ROOT_DIR/../support

execute() {
    echo "Executing: $@"
    eval "$@"
}

if [ ! -d $DM_SUPPORT_DIR ]; then
    echo "Creating new DM support directory $DM_SUPPORT_DIR."
    cd `dirname $DM_SUPPORT_DIR`
    execute svn export $DM_SVN_URL/support support
fi
cd $DM_SUPPORT_DIR
execute svn update
execute $DM_SUPPORT_DIR/bin/clean_support_all.sh
execute $DM_SUPPORT_DIR/bin/install_support_all.sh



