package gov.anl.aps.dm.common.objects;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import gov.anl.aps.dm.common.exceptions.DmException;
import java.io.Serializable;

/**
 * Base DM object class.
 */
public class DmObject implements Serializable {

    protected Long id = null;
    protected String name = null;
    protected String description = null;

    public DmObject() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Conversion to JSON string representation.
     *
     * @return JSON string
     */
    public String toJson() {
        Gson gson = new GsonBuilder().create();
        return gson.toJson(this);
    }

    /**
     * Encode object.
     *
     * @throws DmException in case of any errors
     */
    public void encode() throws DmException {
    }

    /**
     * Decode object.
     *
     * @throws DmException in case of any errors
     */
    public void decode() throws DmException {
    }
}
