package gov.anl.aps.dm.portal.controllers;

import gov.anl.aps.dm.portal.exceptions.DmPortalException;
import gov.anl.aps.dm.portal.exceptions.MissingProperty;
import gov.anl.aps.dm.portal.exceptions.ObjectAlreadyExists;
import gov.anl.aps.dm.portal.model.entities.ExperimentPolicy;
import gov.anl.aps.dm.portal.model.beans.ExperimentPolicyFacade;
import java.util.List;

import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import org.apache.log4j.Logger;

@Named("experimentPolicyController")
@SessionScoped
public class ExperimentPolicyController extends CrudEntityController<ExperimentPolicy, ExperimentPolicyFacade>
{

    private static final Logger logger = Logger.getLogger(ExperimentPolicyController.class.getName());

    @EJB
    private ExperimentPolicyFacade experimentPolicyFacade;

    public ExperimentPolicyController() {
    }

    @Override
    protected ExperimentPolicyFacade getFacade() {
        return experimentPolicyFacade;
    }

    @Override
    protected ExperimentPolicy createEntityInstance() {
        return new ExperimentPolicy();
    }

    @Override
    public String getEntityTypeName() {
        return "experimentPolicy";
    }

    @Override
    public String getCurrentEntityInstanceName() {
        return "";
    }

    @Override
    public List<ExperimentPolicy> getAvailableItems() {
        return super.getAvailableItems();
    }

    @Override
    public String prepareEdit(ExperimentPolicy experimentPolicy) {
        return super.prepareEdit(experimentPolicy);
    }

    @Override
    public void prepareEntityInsert(ExperimentPolicy experimentPolicy) throws ObjectAlreadyExists, MissingProperty {
        logger.debug("Inserting new experiment policy ");
    }

    @Override
    public void prepareEntityUpdate(ExperimentPolicy experimentPolicy) throws DmPortalException {
    }
    
      @Override
     protected String getObjectAlreadyExistMessage(ExperimentPolicy experimentPolicy)  {
        if (experimentPolicy == null) {
            return null;
        }
        return "Experiment Policy " + " already exists."; 
    }

    @FacesConverter(forClass = ExperimentPolicy.class)
    public static class ExperimentPolicyControllerConverter implements Converter
    {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            ExperimentPolicyController controller = (ExperimentPolicyController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "experimentPolicyController");
            return controller.getEntity(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof ExperimentPolicy) {
                ExperimentPolicy o = (ExperimentPolicy) object;
                return getStringKey(o.getId());
            }
            else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + ExperimentPolicy.class.getName());
            }
        }
    }

}