/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.RoleType;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class RoleTypeFacade extends AbstractFacade<RoleType>
{
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public RoleTypeFacade() {
        super(RoleType.class);
    }

    public RoleType findByName(String name) {
        try {
            return (RoleType) em.createNamedQuery("RoleType.findByName")
                    .setParameter("name", name)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

    public RoleType findById(int id) {
        try {
            return (RoleType) em.createNamedQuery("RoleType.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

    public boolean checkIfNameExists(String name) {
        return findByName(name) != null;
    }

}
