/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "policy_type")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "PolicyType.findAll", query = "SELECT p FROM PolicyType p"),
    @NamedQuery(name = "PolicyType.findById", query = "SELECT p FROM PolicyType p WHERE p.id = :id"),
    @NamedQuery(name = "PolicyType.findByName", query = "SELECT p FROM PolicyType p WHERE p.name = :name"),
    @NamedQuery(name = "PolicyType.findByDescription", query = "SELECT p FROM PolicyType p WHERE p.description = :description")})

public class PolicyType extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(max = 256)
    @Column(name = "name")
    private String name;
    @Size(max = 256)
    @Column(name = "description")
    private String description;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyType")
    private List<ExperimentPolicy> experimentPolicyList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyType")
    private List<PolicyProperty> policyPropertyList;

    public PolicyType() {
    }

    public PolicyType(Integer id) {
        this.id = id;
    }

    public PolicyType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<ExperimentPolicy> getExperimentPolicyList() {
        return experimentPolicyList;
    }

    public void setExperimentPolicyList(List<ExperimentPolicy> experimentPolicyList) {
        this.experimentPolicyList = experimentPolicyList;
    }

    @XmlTransient
    public List<PolicyProperty> getPolicyPropertyList() {
        return policyPropertyList;
    }

    public void setPolicyPropertyList(List<PolicyProperty> policyPropertyList) {
        this.policyPropertyList = policyPropertyList;
    }


    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PolicyType)) {
            return false;
        }
        PolicyType other = (PolicyType) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.PolicyType[ id=" + id + " ]";
    }
    
}
