/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "role_type")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "RoleType.findAll", query = "SELECT r FROM RoleType r"),
    @NamedQuery(name = "RoleType.findById", query = "SELECT r FROM RoleType r WHERE r.id = :id"),
    @NamedQuery(name = "RoleType.findByName", query = "SELECT r FROM RoleType r WHERE r.name = :name"),
    @NamedQuery(name = "RoleType.findByDescription", query = "SELECT r FROM RoleType r WHERE r.description = :description")})

public class RoleType extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(max = 256)
    @Column(name = "name")
    private String name;
    @Size(max = 3000)
    @Column(name = "description")
    private String description;
    @NotNull
    @Column(name = "is_system_role")
    private boolean isSystemRole;
    @JoinTable(name = "user_system_role", joinColumns = {
        @JoinColumn(name = "role_type_id", referencedColumnName = "id")}, inverseJoinColumns = {
        @JoinColumn(name = "user_id", referencedColumnName = "id")})
    @ManyToMany
    private List<UserInfo> userInfoList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "roleType")
    private List<UserExperimentRole> userExperimentRoleList;

    public RoleType() {
    }

    public RoleType(Integer id) {
        this.id = id;
    }

    public RoleType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }


    public boolean isIsSystemRole() {
        return isSystemRole;
    }

    public void setIsSystemRole(boolean isSystemRole) {
        this.isSystemRole = isSystemRole;
    }

    @XmlTransient
    public List<UserInfo> getUserInfoList() {
        return userInfoList;
    }

    public void setUserInfoList(List<UserInfo> userInfoList) {
        this.userInfoList = userInfoList;
    }
 
    public void addRoleTypeToUser(UserInfo userInfo) {
        if (userInfoList == null)
            userInfoList = new ArrayList();
        if (!userInfoList.contains(userInfo)) {
            userInfoList.add(userInfo);
        }
    }

    public void removeRoleTypeFromUser(UserInfo userInfo) {
        userInfoList.remove(userInfo);
    }

    public boolean isAdmin(String userName) {
        for (UserInfo userInfo : getUserInfoList())
        {
            if (userInfo.getUsername().equals(userName))
                return true;
        }
        return false;
    }

    @XmlTransient
    public List<UserExperimentRole> getUserExperimentRoleList() {
        return userExperimentRoleList;
    }

    public void setUserExperimentRoleList(List<UserExperimentRole> userExperimentRoleList) {
        this.userExperimentRoleList = userExperimentRoleList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof RoleType)) {
            return false;
        }
        RoleType other = (RoleType) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.RoleType[ id=" + id + " ]";
    }
    
}
