#!/usr/bin/env python

#
# Implementation for file controller.
#

from dm.common.objects.dmObject import DmObject
from dm.common.objects.dmObjectManager import DmObjectManager
from dm.common.mongodb.api.fileMongoDbApi import FileMongoDbApi

class FileSessionControllerImpl(DmObjectManager):
    """ File controller implementation class. """

    def __init__(self):
        DmObjectManager.__init__(self)
        self.fileMongoDbApi = FileMongoDbApi()

    def addExperimentFile(self, fileInfo):
        return self.fileMongoDbApi.addExperimentFile(fileInfo)

    def updateExperimentFile(self, fileInfo):
        return self.fileMongoDbApi.updateExperimentFile(fileInfo)

    def updateFileById(self, fileInfo):
        return self.fileMongoDbApi.updateFileById(fileInfo)

    def getFiles(self, queryDict):
        return self.fileMongoDbApi.getFiles(queryDict=queryDict)

    def getExperimentFiles(self, experimentName, queryDict):
        return self.fileMongoDbApi.getExperimentFiles(experimentName, queryDict=queryDict)

    def getFileById(self, id):
        return self.fileMongoDbApi.getFileById(id)

    def getExperimentFile(self, experimentName, fileName):
        return self.fileMongoDbApi.getExperimentFile(experimentName, fileName)

