#!/usr/bin/env python

#
# Base object manager class.
#

#######################################################################

import threading
from dm.common.utility.loggingManager import LoggingManager

#######################################################################

class DmObjectManager:
    """ Base object manager class. """

    def __init__(self):
        self.logger = LoggingManager.getInstance().getLogger(self.__class__.__name__)
        self.lock = threading.RLock()

    def getLogger(self):
        return self.logger

    def acquireLock(self):
        self.lock.acquire()

    def releaseLock(self):
        self.lock.release()

