#!/usr/bin/env python

from dm.common.constants import dmRole
from dm.common.objects.authorizationPrincipal import AuthorizationPrincipal
from dm.common.db.api.userDbApi import UserDbApi
from dm.common.service.auth.sessionManager import SessionManager
from dm.ds_web_service.api.dsRestApiFactory import DsRestApiFactory


class DsSessionManager(SessionManager):

    def __init__(self):
        SessionManager.__init__(self, self.__class__.__name__)
        self.authApi = DsRestApiFactory.getAuthRestApi()

    def addSession(self, sessionId, sessionInfo):
        return self.authApi.addSession(sessionId, sessionInfo)

    def checkSession(self, sessionId):
        return self.authApi.checkSession(sessionId)

#######################################################################
# Testing.
if __name__ == '__main__':
    pass

